package com.melot.meshow.main


import android.graphics.BitmapFactory
import android.os.Build
import android.os.Bundle
import android.support.annotation.RequiresApi
import android.text.TextPaint
import android.widget.Button
import android.widget.EditText
import com.melot.kkannotation.Autowired
import com.melot.kkcommon.activity.BaseActivity
import com.melot.kkcommon.util.Util
import com.melot.meshow.R
import com.opensource.svgaplayer.*
import java.net.URL

public class SvgaTestActivity : BaseActivity() {
    private var mSVGAImageView: SVGAImageView? = null

    @JvmField
    var path: String? = null

    public override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_svga_test)
        mSVGAImageView = findViewById(R.id.imageView) as SVGAImageView
        mSVGAImageView?.callback = object : SVGACallback {
            override fun onPause() {

            }

            override fun onFinished() {
            }

            override fun onRepeat() {

            }

            override fun onStep(i: Int, v: Double) {
            }
        }
        val nameTv = findViewById(R.id.name_input) as EditText
        path?.let { nameTv.setText(it) }
        val nameTihuan = findViewById(R.id.name_tihan) as EditText

        (findViewById(R.id.btn) as Button).setOnClickListener {
            val parser = SVGAParser(this)
            var txt = nameTv.text.toString()
            if (!nameTv.text.startsWith("http")) {
                txt = "http://10.0.1.25:8080/kktest/file/${nameTv.text}.svga"
            }
            var url = URL(txt)
            parser.parse(url, object : SVGAParser.ParseCompletion {
                override fun onError() {
                    Util.showToast(
                            "parse error")
                }

                @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                override fun onComplete(mSVGAVideoEntity: SVGAVideoEntity) {
//                    val drawable = SVGADrawable(mSVGAVideoEntity)
//                    mSVGAImageView?.setImageDrawable(drawable)
//                    mSVGAImageView?.startAnimation()
                    val dynamicItem = SVGADynamicEntity()
                    var drawable = SVGADrawable(mSVGAVideoEntity, dynamicItem)
                    var textPaint = TextPaint()
                    textPaint.setTextSize(30f)
                    textPaint.setFakeBoldText(true)
                    textPaint.setARGB(0xff, 0x00, 0x00, 0x00)
//                    textPaint.setShadowLayer( 1.0f,  0.0f, 1.0f, Color.BLACK) // 各种配置
                    dynamicItem.setDynamicText("我有回车\n换行", textPaint, "position2")
//                    dynamicItem.setDynamicText("K", textPaint, "toufa")
                    // dynamicItem.setDynamicImage("http://ares.kktv8.com/kktv/webskin/20180509111613_778.png", "yu12");
//                    var bmp = BitmapFactory.decodeResource(getResources(), R.drawable.kk_pk_streak_win_1)
//                    dynamicItem.setDynamicImage(bmp, nameTihuan.text.toString())
                    mSVGAImageView?.setImageDrawable(drawable)
//                    mSVGAImageView?.fillMode = SVGAImageView.FillMode.Forward
                    mSVGAImageView?.startAnimation()
                }
            })
        }

    }
}
