package com.melot.meshow.room.UI.vert.mgr

import android.media.AsyncPlayer
import android.media.AudioManager
import android.net.Uri
import android.view.View
import android.view.ViewGroup
import android.view.ViewStub
import android.widget.ImageView
import android.widget.RelativeLayout
import com.melot.basic.util.KKNullCheck
import com.melot.kkbasiclib.callbacks.Callback1
import com.melot.kkcommon.Global
import com.melot.kkcommon.KKCommonApplication
import com.melot.kkcommon.room.gift.SvgaPlaceHolder
import com.melot.kkcommon.sns.filetrans.NewDownloadManager
import com.melot.kkcommon.sns.filetrans.NewDownloadTask
import com.melot.kkcommon.struct.RoomInfo
import com.melot.kkcommon.util.KKThreadPool
import com.melot.kkcommon.util.Util
import com.melot.meshow.room.R
import com.melot.meshow.room.UI.vert.mgr.modifier.ImageSvgaModifier
import com.melot.meshow.room.UI.vert.mgr.modifier.TextSvgaModifier
import com.opensource.svgaplayer.*
import java.net.MalformedURLException
import java.net.URL

/**
 * 全屏的
 * Created by siwen.hu on 2018/10/31.
 */

class RoomSvgaManager(internal var mRoot: View) : BaseMeshowVertManager() {
    internal var mSvgaImageView: SVGAImageView? = null
    internal var queue = ArrayList<PlayItem>()
    private var playing = false

    override fun onNewRoom(newRoomInfo: RoomInfo) {
        // test()
    }

    private fun test() {
        //TODO for test
        val holders = ArrayList<SvgaPlaceHolder>()
        val h1 = SvgaPlaceHolder()
        h1.type = 1
        h1.value = "http://10.0.1.25:8080/kktest/file/medal1.png"
        h1.width = 96
        h1.height = 96
        holders.add(h1)
        val h11 = SvgaPlaceHolder()
        h11.type = 1
        h11.value = "http://ares.kktv8.com/kktv/portrait/20181106/14/131261608_3353806.jpg!128"
        h11.radius = 48
        h11.width = 96
        h11.height = 96
        holders.add(h11)
        val h2 = SvgaPlaceHolder()
        h2.type = 2
        h2.value = "我是字"
        h2.textSize = 14
        h2.textColor = "ffffff"
        holders.add(h2)
        val h22 = SvgaPlaceHolder()
        h22.type = 2
        h22.value = "哈哈哈哈"
        h22.textSize = 14
        h22.textColor = "ffffff"
        holders.add(h22)
        runOnUIThread {
            // play("http://10.0.1.25:8080/kktest/file/newYear.svga", "https://ares.kktv8.com/kktv/specialEffects/2019springfestival/sound.mp3")
            play("http://10.0.1.25:8080/kktest/file/214.svga", "https://ares.kktv8.com/kktv/specialEffects/2019valentine/sound.mp3", holders)
        }
    }

    override fun destroy() {
        super.destroy()
        queue.clear()
        mSvgaImageView?.let {
            it.stopAnimation()
            it.setImageDrawable(null)
        }
        musicDownloading.isEmpty().not().let {
            musicDownloading.forEach {
                NewDownloadManager.getInstance().cancelDownloadTask(it)
            }
        }
        musicPlayer?.stop()
    }

    //    private fun _play(url: String, callback: SVGACallback?, vararg modifier: Callback1<SVGADrawable>?) {
//        _play(url, callback, modifier?.toList())
//    }
    var musicPlayer: AsyncPlayer? = null

    private fun _play(url: String, musicUrl: String?, loops: Int, isFull: Boolean = true, scaleType: Int = 0, callback: SVGACallback?, modifier: List<Callback1<SVGADrawable>?>?) {
        runOnUIThread {
            initSvgaView(isFull)
            mSvgaImageView?.let {
                when (scaleType) {
                    0 -> it.scaleType = ImageView.ScaleType.FIT_CENTER
                    1 -> it.scaleType = ImageView.ScaleType.CENTER_CROP
                    2 -> it.scaleType = ImageView.ScaleType.FIT_XY
                }
                it.loops = loops
                it.callback = object : SVGACallback {
                    override fun onPause() {
                        callback?.onPause()
                    }

                    override fun onFinished() {
                        callback?.onFinished()
                        playing = false
                        play()
                    }

                    override fun onRepeat() {
                        callback?.onRepeat()
                    }

                    override fun onStep(i: Int, v: Double) {
                        callback?.onStep(i, v)
                    }
                }
                KKThreadPool.getInstance().addTask {
                    val svgaParser = SVGAParser(KKCommonApplication.getInstance())
                    try {
                        svgaParser.parse(URL(url), object : SVGAParser.ParseCompletion {
                            override fun onComplete(svgaVideoEntity: SVGAVideoEntity) {
                                runOnUIThread {
                                    modifier?.let {
                                        val svgaDynamicEntity = SVGADynamicEntity()
                                        val svgaDrawable = SVGADrawable(svgaVideoEntity, svgaDynamicEntity)
                                        modifier.forEach { it?.invoke(svgaDrawable) }
                                        mSvgaImageView?.let {
                                            it.setImageDrawable(svgaDrawable)
                                            it.startAnimation()
                                        }
                                    }
                                }
                                musicUrl?.let {
                                    KKNullCheck.isNull(musicPlayer, {
                                        musicPlayer = AsyncPlayer("RoomSvgaManager")
                                    })
                                    musicPlayer?.play(KKCommonApplication.getInstance(), Uri.parse(it), false, AudioManager.STREAM_MUSIC)
                                }
                            }

                            override fun onError() {}
                        })
                    } catch (e: MalformedURLException) {
                        e.printStackTrace()
                    }
                }
            }
        }
    }


    fun play(url: String, vararg modifier: Callback1<SVGADrawable>) {
        queue.add(PlayItem(url = url, modifier = modifier?.toList()))
        play()
    }

    private fun play() {
        if (playing) return
        if (queue.size > 0) {
            val poll = queue.removeAt(0)
            playing = true
            play(poll)
        }
    }

    private fun play(poll: PlayItem) {
        _play(poll.url, poll.musicUrl, poll.loops, poll.isFull, poll.scaleType, poll.callback, poll.modifier)
    }

    fun play(url: String, callback: SVGACallback) {
        queue.add(PlayItem(url = url, callback = callback))
        play()
    }

    fun play(url: String) {
        queue.add(PlayItem(url = url))
        play()
    }

    fun play(url: String, musicUrl: String? = null, holders: List<SvgaPlaceHolder>? = null, isFull: Boolean = true, loops: Int = 1, scaleType: Int = 0) {
        if (musicUrl.isNullOrEmpty()) {
            playWithMusic(holders, isFull, url, null, loops, scaleType)
        } else {
            download(musicUrl, Callback1 {
                playWithMusic(holders, isFull, url, it, loops, scaleType)
            })
        }
        //  _play(url, null, ps)
    }

    private fun playWithMusic(holders: List<SvgaPlaceHolder>?, isFull: Boolean = true, url: String, musicUrl: String? = null, loops: Int, scaleType: Int) {
        var i = 0
        var ps = ArrayList<Callback1<SVGADrawable>>()
        holders?.forEach {
            if (it.type == SvgaPlaceHolder.TYPE_PIC) {
                var item = ImageSvgaModifier(it, "position$i")
                ps.add(item)
            } else if (it.type == SvgaPlaceHolder.TYPE_TXT) {
                var item = TextSvgaModifier(it.value, "position$i", it.textSize, it.textColor, it.showLength)
                ps.add(item)
            }
            i++
        }
        queue.add(PlayItem(url = url, musicUrl = musicUrl, modifier = ps, isFull = isFull, loops = loops, scaleType = scaleType))
        play()
    }

    var musicDownloading: ArrayList<String> = ArrayList()
    fun download(url: String, path: Callback1<String>?) {
        musicDownloading.add(url)
        val newDownloadTask = NewDownloadTask(mRoot.context, url, Global.APP_SOUND_BGM_CACHE_PATH + url.hashCode(), object : NewDownloadTask.Callback {
            override fun onSuccess(downloadFilepath: String) {
                musicDownloading.remove(url)
                path?.invoke(downloadFilepath)
            }

            override fun onFailed(rc: Long) {
                musicDownloading.remove(url)
            }

            override fun onStart() {
                musicDownloading.remove(url)
            }
        })
        NewDownloadManager.getInstance().startDownload(newDownloadTask)
    }

    private fun initSvgaView(isFull: Boolean) {
        if (mSvgaImageView == null) {
            try {
                val v = mRoot.findViewById<ViewStub>(R.id.svga_image_view_vs)
                mSvgaImageView = v.inflate().findViewById(R.id.svga_image_view)
            } catch (e: Exception) {
                e.printStackTrace()
            }
        }
        mSvgaImageView?.let {
            val lp = it.layoutParams as RelativeLayout.LayoutParams
            if (isFull) {
                if (lp.height != ViewGroup.LayoutParams.MATCH_PARENT) {
                    //动画全屏，view不是全屏，改成全屏
                    lp.height = ViewGroup.LayoutParams.MATCH_PARENT
                    lp.topMargin = 0
                    it.layoutParams = lp
                }
            } else {
                if (lp.height == ViewGroup.LayoutParams.MATCH_PARENT) {
                    //动画非全屏，view是全屏，改成非全屏
                    lp.height = Global.windowsWidth * 3 / 4
                    lp.topMargin = Util.dip2px(83f)
                    it.layoutParams = lp
                }
            }
        }

    }


    data class PlayItem(var url: String, var musicUrl: String? = null, var loops: Int = 1, var scaleType: Int = 0, var isFull: Boolean = true, var callback: SVGACallback? = null, var modifier: List<Callback1<SVGADrawable>?>? = null)
}
