package com.melot.meshow.room.UI.vert.mgr.modifier

import android.graphics.Bitmap

import com.bumptech.glide.Glide
import com.bumptech.glide.request.animation.GlideAnimation
import com.bumptech.glide.request.target.SimpleTarget
import com.melot.basic.util.KKNullCheck
import com.melot.kkcommon.KKCommonApplication
import com.melot.kkcommon.room.gift.SvgaPlaceHolder
import com.melot.kkcommon.util.Util
import com.opensource.svgaplayer.SVGADrawable

import jp.wasabeef.glide.transformations.RoundedCornersTransformation

/**
 * Created by siwen.hu on 2018/10/31.
 */

open class ImageSvgaModifier : BaseSvgaModifier {

    private var mUrl: String = ""
    private var mKey: String = ""
    private var mHolder: SvgaPlaceHolder? = null
    private val mRadius = 0

    constructor(imageUrl: String, forKey: String) {
        mUrl = imageUrl
        mKey = forKey
    }

    constructor(holder: SvgaPlaceHolder?, forKey: String) {
        mKey = forKey
        mHolder = holder
        holder?.let { mUrl = holder.value }
    }

    override fun invoke(svgaDrawable: SVGADrawable) {
        var elseCase = {
            svgaDrawable.dynamicItem.setDynamicImage(mUrl, mKey)
        }
        KKNullCheck.notNull(mHolder, {
            mHolder?.let {
                if (it.radius > 0) {
                    val item = Glide.with(KKCommonApplication.getInstance()).load<Any>(it.value).asBitmap()
                    if (it.width > 0 && it.height > 0) {
                        item.override(it.width, it.height)
                    }
                    item.transform(RoundedCornersTransformation(KKCommonApplication.getInstance(), Util.dip2px(it.radius.toFloat()), 0)).into(object : SimpleTarget<Bitmap>() {
                        override fun onResourceReady(bitmap: Bitmap, glideAnimation: GlideAnimation<in Bitmap>) {
                            svgaDrawable.dynamicItem.setDynamicImage(bitmap = bitmap, forKey = mKey)
                        }
                    })
                } else {
                    elseCase.invoke()
                }
            }
        }, elseCase)
    }
}
