precision mediump float;
varying vec2 vTexCoord;
uniform sampler2D sTexture;
uniform float radius;
uniform float alpha;
void main() {
    vec4 color=texture2D(sTexture, vTexCoord);
    float fix=0.003;
    int seg=int(radius);
    if (seg<=0){
        gl_FragColor = color;
        return;
    }
    int i=1;
    int j=0;
    float r=0.0;
    float g=0.0;
    float b=0.0;
    int count;
    for (i=-seg;i<=seg;i++){
        for (j=-seg;j<=seg;j++){
            if (i==0&&j==0) continue;
            vec4 temp=texture2D(sTexture, vTexCoord+vec2(fix*float(i), fix*float(j)));
            r = r+temp.r;
            g = g+temp.g;
            b = b+temp.b;
            count++;
        }
    }
    float p=float(count);
    gl_FragColor=vec4(r/p, g/p, b/p, color.a*alpha);
}