precision mediump float;
varying vec2 vTexCoord;
uniform sampler2D sTexture;
uniform float radius;
uniform float angels;
uniform vec3 color;
uniform float borderWidth;

vec4 drawAngel(vec2 center)
{
    float r=distance(vTexCoord, center);
    if (r<radius-borderWidth){
        return texture2D(sTexture, vTexCoord);
    } else if (r<radius){
        return vec4(color, 1);
    }
    return vec4(0, 0, 0, 0);
}

void main() {
    float x = vTexCoord.x;
    float y = vTexCoord.y;
    vec2 center;
    int angel =int(angels);
    int draw=0;
    if (angel>=8){
        if (x>1.0-radius&&y>1.0-radius){
            center =  vec2(1.0-radius, 1.0-radius);
            gl_FragColor = drawAngel(center);
            draw=1;
        }
        angel-=8;
    }
    if (angel>=4){
        if (angel>=4&&x<radius&&y>1.0-radius){
            center=vec2(radius, 1.0-radius);
            gl_FragColor = drawAngel(center);
            draw=1;
        }
        angel -=4;
    }
    if (angel>=2){
        if (angel>=2&&x>1.0-radius&&y<radius){
            center = vec2(1.0-radius, radius);
            gl_FragColor = drawAngel(center);
            draw=1;
        }
        angel -=2;
    }
    if (angel>=1 && x<radius&&y<radius){
        center = vec2(radius, radius);
        gl_FragColor = drawAngel(center);
        draw=1;
    }
    if (draw==0) {
        if (x<borderWidth||y<borderWidth||x>1.0-borderWidth||y>=1.0-borderWidth){
            gl_FragColor=vec4(color, 1);
        } else {
            gl_FragColor =texture2D(sTexture, vTexCoord);
        }
    }
}